//Создание задачи диспетчерского вызова прочих задач
function [ActivateState,..//Активированы или деактивированы ли точки запуска
          allActivateState]=GetActivateStateExecPoints(curCommandPointsState)
    //Проверяем аргументы
    [nRez,nArg] = argn();
    if nArg < 1 then
        curCommandPointsState = %t;
    end
    
    //Считываем состояние точек запуска сайлаба
    fullActivateStateFileName = fullfile(SCIHOME,'LanchingTasksInformation','ActivateState.csv');//Полное имя файла точек состояния сайлаба
    if isempty(fileinfo(fullActivateStateFileName)) || curCommandPointsState then
        //Считываем реальное состояние точек запуска сайлаба
        CommandPointsExec = GetCommandPoints()(2,:);
        PathToExecPoints = GetPathToExecPoints();//Получаем полное имя пути к точкам запуска
        fullCommandPointsExec = fullfile(PathToExecPoints,CommandPointsExec);//Полные имена точек запуска
        nCommandPointsExec = size(CommandPointsExec,'*');//Число точек запуска
        ActivateState = [];
        for ind=1:nCommandPointsExec
            //Формируем полное имя файла состояние активации или деактивации точек запуска сайлаба в точке запуска
            fullCommandPointExecActivateStateFile = fullfile(fullCommandPointsExec(ind),'ExecScilab');
            
            //Пишем состояние активации или деактивации точек запуска сайлаба в файл
            ActivateState = [ActivateState,(evstr(mgetl(fullCommandPointExecActivateStateFile)) ~= 0)];
        end
    else
        //Считываем сохраненное состояние точек запуска сайлаба
        ActivateState = (evstr(read_csv(fullActivateStateFileName)) ~= 0);
    end
    
    //Считываем из файла состояние активации или деактивации точек запуска сайлаба
    if nRez > 1 then
        fullActivateStateFileName = fullfile(SCIHOME,'LanchingTasksInformation','ActivateState.txt');//Полное имя файла состояния активации или деактивации точек запуска сайлаба
        if isempty(fileinfo(fullActivateStateFileName)) || curCommandPointsState then
            allActivateState = and(ActivateState);
        else
            allActivateState = (evstr(mgetl(fullActivateStateFileName)) ~= 0);
        end
    end
endfunction
