//Создание задачи диспетчерского вызова прочих задач
function ManageSystemFormalModelingProjectCmdCmdFile(ProjectDirectory,..//Имя директории проекта
                                                     tasksSplit,..//Разделитель доступных задач
                                                     creatingProject,..//Создавать ли проект
                                                     endTasksPoint,..//Удалять ли точки обмена сообщениями
                                                     deletingProject,..//Удалять ли проект
                                                     resultsFiles,..//Файлы с результатами данных
                                                     resultsFilesDirectory,..//Директория, в которую скопируются файлы результатов
                                                     pauseSeconds..//Время паузы (в секундах)
                                                     )
    //Анализируем аргументы
    select argn(2)
    case 0 then
        ProjectDirectory = pwd();
        tasksSplit = ',';
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        endTasksPoint = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        pauseSeconds = 0;
    case 1 then
        if type(ProjectDirectory) == 1 then
            pauseSeconds = ProjectDirectory;
            ProjectDirectory = pwd();
        else
            pauseSeconds = 0;
        end
        tasksSplit = ',';
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        endTasksPoint = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 2 then
        if type(tasksSplit) == 1 then
            pauseSeconds = tasksSplit;
            tasksSplit = ',';
        else
            pauseSeconds = 0;
        end
        creatingProject = [];//По умолчанию спрашиваем у пользователя
        endTasksPoint = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFiles = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 3 then
        if type(creatingProject) == 10 then
            resultsFiles = creatingProject;
            creatingProject = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        elseif (~isempty(creatingProject)) &&..
               (type(creatingProject) == 1) then
            pauseSeconds = creatingProject;
            creatingProject = [];//По умолчанию спрашиваем у пользователя
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        end
        endTasksPoint = [];//По умолчанию спрашиваем у пользователя
        deletingProject = [];//По умолчанию спрашиваем у пользователя
        resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
    case 4 then
        if type(creatingProject) == 10 then
            resultsFiles = creatingProject;
            if type(endTasksPoint) == 10 then
                resultsFilesDirectory = endTasksPoint;
                pauseSeconds = 0;
            else
                pauseSeconds = endTasksPoint;
                resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            end
            creatingProject = [];//По умолчанию спрашиваем у пользователя
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        elseif type(endTasksPoint) == 10 then
            resultsFiles = endTasksPoint;
            resultsFilesDirectory = [];
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        elseif (~isempty(endTasksPoint)) &&..
               (type(endTasksPoint) == 1) then
            pauseSeconds = endTasksPoint;
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        else
            deletingProject = [];//По умолчанию спрашиваем у пользователя
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        end
    case 5 then
        if type(creatingProject) == 10 then
            pauseSeconds = deletingProject;
            resultsFilesDirectory = endTasksPoint;
            resultsFiles = creatingProject;
            creatingProject = [];//По умолчанию спрашиваем у пользователя
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        elseif type(endTasksPoint) == 10 then
            resultsFiles = endTasksPoint;
            if type(deletingProject) == 10 then
                resultsFilesDirectory = deletingProject;
                deletingProject = [];//По умолчанию спрашиваем у пользователя
                pauseSeconds = 0;
            else
                pauseSeconds = deletingProject;
                deletingProject = [];//По умолчанию спрашиваем у пользователя
                resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            end
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
        elseif type(deletingProject) == 10 then
            resultsFiles = deletingProject;
            deletingProject = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        elseif (~isempty(deletingProject)) &&..
               (type(deletingProject) == 1) then
            pauseSeconds = deletingProject;
            deletingProject = [];//По умолчанию спрашиваем у пользователя
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        end
    case 6 then
        if type(endTasksPoint) == 10 then
            pauseSeconds = resultsFiles;
            resultsFiles = endTasksPoint;
            resultsFilesDirectory = deletingProject;
            endTasksPoint = [];//По умолчанию спрашиваем у пользователя
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        elseif type(deletingProject) == 10 then
            if (~isempty(resultsFiles)) &&..
               (type(resultsFiles) == 1) then
                pauseSeconds = resultsFiles;
                resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            else
                resultsFilesDirectory = resultsFiles;
                pauseSeconds = 0;
            end
            resultsFiles = deletingProject;
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        elseif (~isempty(resultsFiles)) &&..
               (type(resultsFiles) == 1) then
            pauseSeconds = resultsFiles;
            resultsFiles = [];//По умолчанию спрашиваем у пользователя
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
        else
            resultsFilesDirectory = [];//По умолчанию спрашиваем у пользователя
            pauseSeconds = 0;
        end
    case 7 then
        if type(deletingProject) == 10 then
            pauseSeconds = resultsFilesDirectory;
            resultsFilesDirectory = resultsFiles;
            resultsFiles = deletingProject;
            deletingProject = [];//По умолчанию спрашиваем у пользователя
        else
            pauseSeconds = 0;
        end
    end
    
    //Проверяем корректность аргументов
    if (type(ProjectDirectory) ~= 10) ||..
       (size(ProjectDirectory,"*") > 1) then
        error("The arguments ProjectDirectory of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar string");
    end
    if (type(tasksSplit) ~= 10) || (size(tasksSplit,"*") > 1) then
        error("The arguments tasksSplit of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar string");
    end
    if (~isempty(creatingProject)) &&..
       ((type(creatingProject) ~= 4) ||..
        (size(creatingProject,"*") > 1)) then
        error("The arguments creatingProject of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar boolean");
    end
    if (~isempty(endTasksPoint)) &&..
       ((type(endTasksPoint) ~= 4) ||..
        (size(endTasksPoint,"*") > 1)) then
        error("The arguments endTasksPoint of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar boolean");
    end
    if (~isempty(deletingProject)) &&..
       ((type(deletingProject) ~= 4) ||..
        (size(deletingProject,"*") > 1)) then
        error("The arguments deletingProject of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar boolean");
    end
    if (~isempty(resultsFiles)) && (type(resultsFiles) ~= 10) then
        error("The arguments resultsFiles of function ManageSystemFormalModelingProjectCmdCmdFile must be matrix of string");
    end
    if (~isempty(resultsFilesDirectory)) &&..
       ((type(resultsFilesDirectory) ~= 10) ||..
        (size(resultsFilesDirectory,"*") > 1)) then
        error("The arguments resultsFilesDirectory of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar string");
    end
    if (type(pauseSeconds) ~= 1) ||..
       (size(pauseSeconds,"*") > 1) then
        error("The arguments pauseSeconds of function ManageSystemFormalModelingProjectCmdCmdFile must be scalar real");
    end
    
    //Обрабатываем аргументы
    if isempty(ProjectDirectory) then
        ProjectDirectory = pwd();
    end
    if isempty(tasksSplit) then
        tasksSplit = ",";
    end
    
    //Получаем статус активированности точек запуска
    isActivateExecPoints = GetActivateStateExecPoints(%f);//Получаем информацию о точках обмена
    
    //Активируем точки
    SetActivateStateExecPoints(%t,%f);
    global isAllActivateExecPoints;
    isAllActivateExecPoints = %t;
    
    //Получаем имя проекта
    ProjectName = GetProjectName();

    //Функция чтения команды
    function [messages,isQuesion]=readCommandFromFile(CommandPoint)
        //Читаем информацию из файла
        [messages,..//Сообщения
         isNewQuesion,..//Новый вопрос ли?
         isQuesion,..
         isAnsweredQuesion]=ReadCommandFromFile(CommandPoint);
         
        //Это вопрос, на который не получен ответ?
        isQuesion = isQuesion && (~isAnsweredQuesion);
    endfunction
    
    //Функция записи команды
    function err = askToQuensionToFile(messages,..//Ответ (сообщения ответов)
                                       CommandFilePointName,..//Точка обмена сообщениями
                                       pauseSecond..//Задержка после ответа на вопрос (в секундах)
                                       )
        //Проверяем сообщения
        if isAllActivateExecPoints && isempty(messages) then
            //Возвращаем точкам прежний статус активации
            SetActivateStateExecPoints(isActivateExecPoints,%f);
            
            //Присваиваем новый статус переменной деактивированности точек
            global isAllActivateExecPoints;
            isAllActivateExecPoints = %f;
            
            //Приостанавливаем выполнение функции
            sleep(pauseSecond,"s");
        end
        
        //Запишем команду в файл
        err = AskToQuensionToFile(messages,CommandFilePointName,pauseSecond);
    endfunction
    
    //Типовые вопросы
    endTasksStrEt = "Are all tasks solved?";
    lEndTasksStrEt = length(endTasksStrEt);
    createProjectStrEt = "Create project?";
    lCreateProjectStrEt = length(createProjectStrEt);
    endTasksPointsStrEt = "End tasks points?";
    lEndTasksPointsStrEt = length(endTasksPointsStrEt);
    deleteProjectStrEt = "Delete project?";
    lDeleteProjectStrEt = length(deleteProjectStrEt);
    reseiveRezultsFilesStrEt = "Receive rezults'' datas files?";
    lReseiveRezultsFilesStrEt = length(reseiveRezultsFilesStrEt);
    rezultsFilesStrEt = "Results'' files names:";
    lRezultsFilesStrEt = length(rezultsFilesStrEt);
    rezultsFilesDirectoryStrEt = "Results'' files directory(ies) name:";
    lRezultsFilesDirectoryStrEt = length(rezultsFilesDirectoryStrEt);
    
    //Функция получения сообщения от пользователя
    function [msg]=ReadUserFunction(askStr)
        askStr = stripblanks(askStr);//Удаляем лишние пробелы
        if part(askStr,[1:lEndTasksStrEt]) == endTasksStrEt then
            msg = "y";
        elseif (part(askStr,[1:lCreateProjectStrEt]) == createProjectStrEt) &&.. 
               (~isempty(creatingProject)) then
            if creatingProject then
                msg = "Y";
            else
                msg = "N";
            end
        elseif (part(askStr,[1:lEndTasksPointsStrEt]) == endTasksPointsStrEt) &&.. 
               (~isempty(endTasksPoint)) then
            if endTasksPoint then
                msg = "Y";
            else
                msg = "N";
            end
        elseif (part(askStr,[1:lDeleteProjectStrEt]) == deleteProjectStrEt) &&.. 
               (~isempty(deletingProject)) then
            if deletingProject then
                msg = "Y";
            else
                msg = "N";
            end
        elseif (part(askStr,[1:lReseiveRezultsFilesStrEt]) == reseiveRezultsFilesStrEt) &&.. 
               (~isempty(resultsFiles)) then
            msg = "Y";
        elseif (part(askStr,[1:lRezultsFilesStrEt]) == rezultsFilesStrEt) &&.. 
               (~isempty(resultsFiles)) then
            msg = strcat(resultsFiles,",");
        elseif (part(askStr,[1:lRezultsFilesDirectoryStrEt]) == rezultsFilesDirectoryStrEt) &&.. 
               (~isempty(resultsFilesDirectory)) then
            msg = resultsFilesDirectory;
        else
            msg = input(askStr + " ","s");
        end
    endfunction
    
    //Функция обработки ошибок
    function ErrorFunctionCmd(regCode,errMsg,CommandPoint,ProjectName)
        if regCode == 0 then
            disp('Project ' + ProjectName + ': ' + CommandPoint + ' is busy');
        else
            msgStr = 'Project ' + ProjectName + ': ' + CommandPoint + ': Error execute, Code: ' + string(regCode) + ': ';
            if size(errMsg,'*') > 1 then
                disp(msgStr);
                disp(errMsg);
            else
                msgStr = msgStr + errMsg;
                disp(msgStr);
            end
        end
    endfunction
    
    //Функция действий после регистрации задачи
    function AfterRegistrationTasksFunctionCmd(CommandPoint,Task,ProjectName)
        disp('Project ' + ProjectName + ': The task ' + Task + ' on command point ' + CommandPoint + ' is registered sucsessfully!');
    endfunction
    
    //Функция проверки точки обмена сообщениями
    function regCode = IsRegisteredMessageFilePointCmd(CommandPoint)
        if isRegisteredMessageFilePoint(CommandPoint) &&..
           AskExecPoints(CommandPoint) then
            regCode = 0;
        else
            regCode = 1;
        end
    endfunction
    
    //Выбор задачи для запуска
    function [launchTask]=SelectLaunchTask(enabledTasks,..
                                           commandPoints,..
                                           CommandPoint)
        launchTask = enabledTasks(1);
    endfunction

    //Запускаем проект с соответсвующими функциями ввода-вывода
    ManageSystemFormalModelingProject('AfterRegistrationTasksFunctionCmd',..//Функция, вызываемая после регистрации задач
                                      'ErrorFunctionCmd',..//Функция нештатных ситуаций
                                      'ReadUserFunction',..//Функция получения сообщения от пользователя
                                      'disp',..//Функция отправки сообщения пользователю
                                      'dispCommandToFile',..//Функция отправки сообщения от задач
                                      'readCommandFromFile',..//Функция получения сообщения с точки
                                      'askToQuensionToFile',..//Функция отправки сообщения на точку
                                      'IsRegisteredMessageFilePointCmd',..//Функция проверки регистрации точки обмена сообщениями
                                      'SelectLaunchTask',..//Функция выбора задачи для запуска на текущем вычислительном узле
                                      ProjectDirectory,..//Имя директории проекта
                                      ProjectName,..//Имя проекта
                                      tasksSplit,..//Разделитель доступных задач
                                      pauseSeconds..//Время паузы (в секундах)
                                      );
endfunction
