//Создание задачи диспетчерского вызова прочих задач
function SetProjectName(ProjectName,..//Имя проекта
                        pauseSeconds..//Время паузы (в секундах)
                        )
    //Анализируем аргументы
    nArg = argn(2);
    if nArg < 1 then
        error('The function SetProjectName takes 1 or 2 argument');
    elseif nArg == 1 then
        pauseSeconds = 0;//Время паузы (в секундах)
    end
    
    //Полное имя файла проекта
    fullProjectNameFileName = fullfile(SCIHOME,'LanchingTasksInformation','ProjectName.txt');
    
    //Записывем в файл имя проекта
    mputl(ProjectName,fullProjectNameFileName);
    
    //Записываем в точки имя проекта
    allCommandPoints = GetCommandPoints()([1, 2],:);
    CommandPointsExec = allCommandPoints(2,:);//Получаем точки запуска
    PathToExecPoints = GetPathToExecPoints();//Получаем полное имя пути к точкам запуска
    fullCommandPointsExec = fullfile(PathToExecPoints,CommandPointsExec);//Полные имена точек запуска
    for fullCommandPointExec=fullCommandPointsExec
        //Формируем полное имя файла проекта в точке запуска
        fullCommandPointExecProjectNameFile = fullfile(fullCommandPointExec,'ProjectName');
        
        //Пишем имя проекта в файл
        mputl(ProjectName,fullCommandPointExecProjectNameFile);
    end
    
    //Берем активные точки
    activeCommandPointsInd = GetActivateStateExecPoints();
    activeCommandPoints = allCommandPoints(1,activeCommandPointsInd);
    
    //Функция чтения команды
    function [messages,isQuesion]=readCommandFromFile(CommandPoint)
        //Читаем информацию из файла
        [messages,..//Сообщения
         isNewQuesion,..//Новый вопрос ли?
         isQuesion,..
         isAnsweredQuesion]=ReadCommandFromFile(CommandPoint);
         
        //Это вопрос, на который не получен ответ?
        isQuesion = isQuesion && (~isAnsweredQuesion);
    endfunction
    
    //Функция обработки ошибок
    function ErrorFunctionCmd(regCode,errMsg,CommandPoint,ProjectName)
        if regCode == 0 then
            disp('Project ' + ProjectName + ': ' + CommandPoint + ' is busy');
        else
            msgStr = 'Project ' + ProjectName + ': ' + CommandPoint + ': Error execute, Code: ' + string(regCode) + ': ';
            if size(errMsg,'*') > 1 then
                disp(msgStr);
                disp(errMsg);
            else
                msgStr = msgStr + errMsg;
                disp(msgStr);
            end
        end
    endfunction
    
    //Функция проверки точки обмена сообщениями
    function regCode = IsRegisteredMessageFilePointCmd(CommandPoint)
        if isRegisteredMessageFilePoint(CommandPoint) &&..
           AskExecPoints(CommandPoint) then
            regCode = 0;
        else
            regCode = 1;
        end
    endfunction
    
    //Перезагружаем активные точки
    EndCommandPoints('ErrorFunctionCmd','disp','readCommandFromFile',..
                     "AskToQuensionToFile",'IsRegisteredMessageFilePointCmd',..
                     activeCommandPoints,ProjectName,pauseSeconds);
endfunction
